#!/usr/bin/perl

#┌─────────────────────────────────
#│ Cosmo Navigator : edit.cgi - 2022/05/14
#│ Copyright (c) TRANSFORM
#│ http://www.kent-web.com/
#└─────────────────────────────────
# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use vars qw(%in %cf);
use lib "./lib";
use CGI::Minimal;

# 設定ファイル認識
require "./init.cgi";
%cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
error('容量オーバー') if ($cgi->truncated);
%in = parse_form($cgi);

# 条件分岐
if ($in{mode} eq 'edit') { edit_form(); }
if ($in{mode} eq 'dele') { dele_data(); }
if ($in{update_html}) { update_html(); }

error("不明な処理です");

#-----------------------------------------------------------
#  修正フォーム
#-----------------------------------------------------------
sub edit_form {
	$in{no} =~ s/\D//g;
	if ($in{pw} eq '') { error("暗証キーが未入力です"); }

	# 実行
	if ($in{job} eq 'edit') { edit_data(); }

	# ログ展開
	my ($log,@data);
	open(DAT,"+< $cf{datadir}/data.dat") or &error("open err: $cf{datadir}/data.dat");
	eval "flock(DAT, 2);";
	while(<DAT>) {
		my ($no,$cls1,$cls2,$sub,$url,$nam,$eml,$msg,$tim,$reco,$hos,$ex,$w,$h,$pw) = split(/<>/);

		if ($in{no} == $no) {
			$log = $_;

			# 画像削除
			if ($in{imgdel}) {
				unlink("$cf{upldir}/$in{no}$ex");
				$ex = $w = $h = '';
			}

			next;
		}
		push(@data,$_);
	}

	my ($no,$cat,$scat,$sub,$url,$nam,$eml,$msg,$tim,$reco,$hos,$ex,$w,$h,$pwd) = split(/<>/, $log);
	$msg =~ s/<br>/\n/g;

	# 非対象
	if (!$log || !$pwd) { error("認証できません"); }

	# 照合
	if (decrypt($in{pw},$pwd) != 1) { &error("認証できません"); }

	# テンプレート読込
	open(IN,"$cf{tmpldir}/edit.html") or error("open err: edit.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# カテゴリ
	my @categ = split(/;/,$cf{categ});
	my $op_cate;
	foreach (0 .. $#categ) {
		my @cat = split(/,/,$categ[$_]);

		for my $c (1 .. $#cat) {
			if ("$cat:$scat" eq "$_:$c") {
				$op_cate .= qq|<option value="$_:$c" selected>$cat[0] &gt; $cat[$c]\n|;
			} else {
				$op_cate .= qq|<option value="$_:$c">$cat[0] &gt; $cat[$c]\n|;
			}
		}
	}

	# 引数
	my $hidden = <<EOM;
<input type="hidden" name="no" value="$in{no}">
<input type="hidden" name="pw" value="$in{pw}">
<input type="hidden" name="job" value="edit">
EOM

	# 文字置き換え
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!(title|[a-z]+_cgi|cmnurl|com_limit)!/$cf{$1}/g;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="$1" class="icon">|g;
	$tmpl =~ s|!topurl!|$cf{rooturl}/index.html|g;
	$tmpl =~ s/!mode!/$in{mode}/g;
	$tmpl =~ s/<!-- hidden -->/$hidden/;
	$tmpl =~ s/<!-- op_cate -->/$op_cate/;
	$tmpl =~ s/!fm-nam!/$nam/g;
	$tmpl =~ s/!fm-eml!/$eml/g;
	$tmpl =~ s/!fm-url!/$url/g;
	$tmpl =~ s/!fm-sub!/$sub/g;
	$tmpl =~ s/!fm-com!/$msg/g;
	$tmpl =~ s/!max_w!/$cf{max_img_w}/g;
	$tmpl =~ s/!max_h!/$cf{max_img_h} /g;

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	# フッタ
	print footer();
	exit;
}

#-----------------------------------------------------------
#  記事削除
#-----------------------------------------------------------
sub dele_data {
	$in{no} =~ s/\D//g;

	if ($in{pw} eq '') { error("暗証キーが未入力です"); }

	# カテゴリ情報
	my %cat = categ();
	
	my $c1num = 0;
	my $c2num = 0;
	my ($flg,$pwd,$ext,$cate1,$cate2,@log,@clog,%clnk,%tlnk);
	open(DAT,"+< $cf{datadir}/data.dat");
	eval "flock(DAT,2);";
	while(<DAT>) {
		my ($no,$cat1,$cat2,$sub,$url,$nam,$eml,$msg,$tim,$rec,$ip,$ex,$w,$h,$pw) = split(/<>/);
		
		# カテゴリ情報を取得
		if ($in{no} == $no) {
			$cate1 = $cat1;
			$cate2 = $cat2;
			last;
		}
	}
	
	# 巻き戻す
	seek(DAT,0,0);

	# ログ展開
	while(<DAT>) {
		my ($no,$cat1,$cat2,$sub,$url,$nam,$eml,$msg,$tim,$rec,$ip,$ex,$w,$h,$pw) = split(/<>/);

		if ($in{no} == $no) {
			$flg++;
			$pwd = $pw;
			$ext = $ex;
			next;
		}

		$tlnk{$cat1}++;
		$tlnk{"$cat1-$cat2"}++;
		if ($cate1 == $cat1) {
			$c1num++;
			push(@clog,$_);
			if ($cate2 == $cat2) { $c2num++; }
			$clnk{"$cat1-$cat2"}++;
		}

		push(@log,$_);
	}

	# 照合
	if (decrypt($in{pw},$pwd) != 1) { error("認証できません"); }

	# 更新
	seek(DAT, 0, 0);
	print DAT @log;
	truncate(DAT, tell(DAT));
	close(DAT);

	# 添付削除
	if ($ext) {
		unlink("$cf{upldir}/$in{no}$ext");
		unlink("$cf{upldir}/$in{no}-s$ext") if (-f "$cf{upldir}/$in{no}-s$ext");
	}

		# データNo
		open(DAT,"+< $cf{datadir}/num.dat") or error("open err: num.dat");
		eval "flock(DAT,2);";
		my $num = <DAT> - 1;
		seek(DAT,0,0);
		print DAT $num;
		truncate(DAT,tell(DAT));
		close(DAT);

	# カウントデータ削除
	unlink("$cf{rankdir}/$in{no}.dat");
	
	my $all = @log;
	
	# HTML更新
	update_html($in{cate1},\%cat,$c1num,\@clog,$all,\%clnk,\%tlnk);

	# 完了
	message("登録データを削除しました。");
}

#-----------------------------------------------------------
#  修正実行
#-----------------------------------------------------------
sub edit_data {
	# 入力チェック
	input_check();

	# カテゴリ情報
	my ($cate1,$cate2) = split(/:/, $in{cate});
	
	my $c1num = 0;
	my $c2num = 0;
	# ログ展開
	my ($flg,$url_flag,$eml_flag,$pw2,@data,$ext2,$w2,$h2,@clog,%clnk,%tlnk,@cls1,@cls2,@reco);
	open(DAT,"+< $cf{datadir}/data.dat") or error("open err: $cf{datadir}/data.dat");
	eval "flock(DAT, 2);";
	while(<DAT>) {
		my ($no,$cat1,$cat2,$sub,$url,$nam,$eml,$msg,$tim,$reco,$hos,$ex,$w,$h,$pw) = split(/<>/);

		if ($in{no} == $no) {
			$flg++;


			# アップロード
			if ($in{upfile}) {
				($ext2,$w2,$h2) = upload($in{no});
			}

			# 画像削除
			if ($in{imgdel}) {
				unlink("$cf{upldir}/$in{no}$ex");
				$ex = $w = $h = '';
			}

			# 添付アップロードの場合
			if ($ext2) {
				# 拡張子変更の場合旧ファイル削除
				if ($ex && $ext2 ne $ex) {
					unlink("$cf{upldir}/$in{no}$ex");
				}
				# 新添付ファイル情報
				($ex,$w,$h) = ($ext2,$w2,$h2);
			}

			$_ = "$no<>$cate1<>$cate2<>$in{sub}<>$in{url}<>$in{name}<>$in{email}<>$in{comment}<>$tim<>$reco<>$hos<>$ex<>$w<>$h<>$pw<>\n";
			$cat1 = $cate1;
			$cat2 = $cate2;
			$pw2 = $pw;
		} else {
			# 重複チェック
			if (!$cf{w_url_regist} && $in{url} eq $url) {
				$url_flag++; last;
			}
			if (!$cf{w_eml_regist} && $in{email} eq $eml) {
				$eml_flag++; last;
			}
		}

		$tlnk{$cat1}++;
		$tlnk{"$cat1-$cat2"}++;
		if ($in{cate1} == $cat1) {
			$c1num++;
			push(@clog,$_);
			if ($in{cate2} == $cat2) { $c2num++; }
			$clnk{"$cat1-$cat2"}++;
		}

		push(@data,$_);
		push(@cls1,$cat1);
		push(@cls2,$cat2);
		push(@reco,$reco);
	}

	if (!$flg) { error("該当するデータが存在しません"); }

	# 重複登録禁止
	if ($url_flag) { error("このURLは既に登録済みです"); }
	if ($eml_flag) { error("このE-mailは既に登録済みです"); }

	# 照合
	if (!$pw2) { error("この記事は修正できません"); }
	if (decrypt($in{pw},$pw2) != 1) { error("暗証キーが違います"); }

	# ソート
	@data = @data[sort { $cls1[$a] <=> $cls1[$b] || $reco[$b] <=> $reco[$a] || $cls2[$a] <=> $cls2[$b] } 0..$#cls1];

	# 更新
	seek(DAT, 0, 0);
	print DAT @data;
	truncate(DAT, tell(DAT));
	close(DAT);

	my $all = @data;
	
	# HTML更新
	update_html($in{cate1},$cate1,$cate2,$c1num,\@clog,$all,\%clnk,\%tlnk);

	# 完了
	message("登録データを修正しました。");
}

#-----------------------------------------------------------
#  再構築
#-----------------------------------------------------------
sub update_html {
	my %cate = categ();
	my ($all,@clog,%clnk,%tlnk,%cat);
	open(DAT,"$cf{datadir}/data.dat");
	while(<DAT>) {
		$all++;
		my ($no,$cat,$scat,$sub,$url,$name,$eml,$msg,$time,$rec,$ip,$ex,$w,$h,$pw) = split(/<>/);
		
		$tlnk{$cat}++;
		$tlnk{"$cat-$scat"}++;
		$cat{$cat}++;
		$clnk{$cat}{"$cat-$scat"}++;
		
		push(@{$clog[$cat]},$_);
	}
	close(DAT);
	
	my $i = 0;
	for my $cat1 ( keys %cat ) {
		my %clnk2;
		for ( keys %{$clnk{$cat1}} ) {
			$clnk2{$_} = $clnk{$cat1}{$_};
		}
		make_html($cat1,\%cate,$cat{$cat1},\@{$clog[$cat1]},$all,\%clnk2,\%tlnk,$i);
		$i++;
	}
}

#-----------------------------------------------------------
#  HTML生成
#-----------------------------------------------------------
sub make_html {
	my ($cat1,$cat,$c1num,$clog,$all,$clnk,$tlnk,$upd) = @_;
	
	my @categ = split(/;/,$cf{categ});
	
	# テンプレート
	open(IN,"$cf{tmpldir}/list.html") or error("open err: list.html");
	my $tmpl = join('',<IN>);
	close(IN);
	
	# 文字置き換え
	$tmpl =~ s|<!-- add_form -->.+?<!-- /add_form -->||gs if ($cf{reg_type} != 1);
	$tmpl =~ s/!(title|navi_cgi|cmnurl|new_mark|admin_cgi)!/$cf{$1}/g;
	$tmpl =~ s|!topurl!|$cf{rooturl}/index.html|g;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" class="icon" alt="$1">|g;
	$tmpl =~ s/<!-- op_cond -->/op_cond()/e;
	$tmpl =~ s/<!-- op_list -->/op_list()/e;
	$tmpl =~ s/!cat1!/$cat1/g;
	$tmpl =~ s/!word!//g;
	
	# テンプレート分割
	my ($head,$loop,$foot) = $tmpl =~ m|(.+)<!-- loop -->(.+?)<!-- /loop -->(.+)|s
			? ($1,$2,$3) : error("テンプレート不正");
	
	# 更新前HTMLを覚えておく
	my @old1 = glob("$cf{rootdir}/html/$cat1-*.html");
	my @old2 = glob("$cf{rootdir}/html/$cat1/*.html");
	
	# 大カテゴリ展開
	my ($i,$n,$html,%tmp,%new1,%new2);
	for (@{$clog}) {
		my ($no,$ct1,$ct2,$sub,$url,$nam,$eml,$msg,$tim,$rec,$ip,$ex,$w,$h,$pw) = split(/<>/);
		$msg =~ s/\t/<br>/g;
		$i++;
		$tmp{$ct2} .= "$_\0";
		
		if ($i % $cf{pg_max} == 1) {
			$n++;
			$html = $head;
		}
		
		# リンクバナー
			my $banner;
			if ($ex) {

				if ($ex =~ /jpg$|gif$|png$/) {
					my $op;
					if (-f "$cf{upldir}/$no-s$ex") {
						$op = qq|src="$cf{uplurl}/$no-s$ex"|;
					} else {
						($w,$h) = &resize($w,$h);
						$op = qq|src="$cf{uplurl}/$no$ex" width="$w" height="$h"|;
					}
					$banner .= qq|<div class="ext"><a href="$cf{navi_cgi}?site=$no&url=$url" target="$cf{target}"><img $op border="0"></a></div>|;
				}
			} elsif ($ex eq '') {
					$banner .= qq|<div class="ext"><a href="$cf{navi_cgi}?site=$no&url=$url" target="$cf{target}"><img src="$cf{nobanner}" width="$cf{nobw}" height="$cf{nobh}" border="0"></a></div>|;
		}

		my $tmp = $loop;
		$tmp =~ s|!name!|$nam|g;
		$tmp =~ s|!comment!|$msg|g;
		$tmp =~ s|!site-name!|<a href="$cf{navi_cgi}?site=$no&url=$url">$sub</a>|g;
		$tmp =~ s/!date!/chg_date($tim)/e;
		$tmp =~ s/!cate!/$$cat{$ct1}{0}/;
		$tmp =~ s/!sub!/$$cat{$ct1}{$ct2}/;
		$tmp =~ s/!num!/$no/;
		$tmp =~ s/<!-- banner -->/$banner/g;
		$tmp =~ s/!new!/chg_date($tim,'new')/e;
		$tmp =~ s|<!-- recom -->|<img src="$cf{cmnurl}/recom.gif" class="icon" alt="recom">|g if ($rec == 1);
		
		$html .= $tmp;
		
		if ($i % $cf{pg_max} == 0) {
			$html .= $foot;
			$html =~ s/!hit!/$c1num/;
			$html =~ s/!navi-ttl!/$$cat{$cat1}{0}/;
			$html =~ s/!keyword!/$$cat{$cat1}{0}/;
			$html =~ s/<!-- pager -->/make_pager($c1num,$n,$cat1,undef)/e;
			$html =~ s|<!-- cat_cell -->(.+?)<!-- /cat_cell -->|cat_cell($1,$categ[$cat1],$cat1,$clnk)|se;
			
			# HTML生成 [大カテゴリ]
			open(DAT,"> $cf{rootdir}/html/$cat1-$n.html");
			print DAT $html;
			close(DAT);
			
			$new1{"$cf{rootdir}/html/$cat1-$n.html"}++;
		}
	}
	
	# ページ端数処理
	if ($i % $cf{pg_max} != 0) {
		$html .= $foot;
		$html =~ s/!hit!/$c1num/;
		$html =~ s/!navi-ttl!/$$cat{$cat1}{0}/;
		$html =~ s/!keyword!/$$cat{$cat1}{0}/;
		$html =~ s/<!-- pager -->/make_pager($c1num,$n,$cat1,undef)/e;
		$html =~ s|<!-- cat_cell -->(.+?)<!-- /cat_cell -->|cat_cell($1,$categ[$cat1],$cat1,$clnk)|se;
		
		# HTML生成 [大カテゴリ]
		open(DAT,"> $cf{rootdir}/html/$cat1-$n.html");
		print DAT $html;
		close(DAT);
		
		$new1{"$cf{rootdir}/html/$cat1-$n.html"}++;
	}
	
	# 小カテゴリ展開
	while( my ($key,$val) = each %tmp ) {
		my $cat2 = $key;
		my @tmp = split(/\0/,$val);
		my $c2num = @tmp;
		
		if (!-d "$cf{rootdir}/html/$cat1") { mkdir("$cf{rootdir}/html/$cat1",0755); }
		my ($i,$n,$html);
		for (@tmp) {
			my ($no,$ct1,$ct2,$sub,$url,$nam,$eml,$msg,$tim,$rec,$ip,$ex,$w,$h,$pw) = split(/<>/);
			$msg =~ s/\t/<br>/g;
			$i++;
			if ($i % $cf{pg_max} == 1) {
				$n++;
				$html = $head;
			}

			# リンクバナー
			my $banner;
			if ($ex) {

				if ($ex =~ /jpg$|gif$|png$/) {
					my $op;
					if (-f "$cf{upldir}/$no-s$ex") {
						$op = qq|src="$cf{uplurl}/$no-s$ex"|;
					} else {
						($w,$h) = &resize($w,$h);
						$op = qq|src="$cf{uplurl}/$no$ex" width="$w" height="$h"|;
					}
					$banner .= qq|<div class="ext"><a href="$cf{navi_cgi}?site=$no&url=$url" target="$cf{target}"><img $op border="0"></a></div>|;
				}
			} elsif ($ex eq '') {
					$banner .= qq|<div class="ext"><a href="$cf{navi_cgi}?site=$no&url=$url" target="$cf{target}"><img src="$cf{nobanner}" width="$cf{nobw}" height="$cf{nobh}" border="0"></a></div>|;
			}
			
			my $tmp = $loop;
			$tmp =~ s|!name!|$nam|g;
			$tmp =~ s|!comment!|$msg|g;
			$tmp =~ s|!site-name!|<a href="$cf{navi_cgi}?site=$no&url=$url">$sub</a>|g;
			$tmp =~ s/!date!/chg_date($tim)/e;
			$tmp =~ s/!cate!/$$cat{$ct1}{0}/;
			$tmp =~ s/!sub!/$$cat{$ct1}{$ct2}/;
			$tmp =~ s/!num!/$no/;
			$tmp =~ s/<!-- banner -->/$banner/g;
			$tmp =~ s/!new!/chg_date($tim,'new')/e;
			$tmp =~ s|<!-- recom -->|<img src="$cf{cmnurl}/cool.gif" class="icon" alt="Cool">|g if ($rec == 1);
			
			$html .= $tmp;
			
			if ($i % $cf{pg_max} == 0) {
				$html .= $foot;
				$html =~ s/!hit!/$c2num/;
				$html =~ s/!navi-ttl!/$$cat{$cat1}{$cat2}/;
				$html =~ s/!keyword!/$$cat{$cat1}{0} : $$cat{$cat1}{$cat2}/;
				$html =~ s|<!-- navi_nest -->|<a href="$cf{rooturl}/html/$cat1-1.html">$$cat{$cat1}{0}</a> &gt;|;
				$html =~ s/<!-- pager -->/make_pager($c2num,$n,$cat1,$cat2)/e;
				$html =~ s|<!-- cat_cell -->.+?<!-- /cat_cell -->||s;
				$html =~ s/<!-- cat2 -->/<input type="hidden" name="cat2" value="$cat2">/;
				
				# HTML生成 [小カテゴリ]
				open(DAT,"> $cf{rootdir}/html/$cat1/$cat2-$n.html");
				print DAT $html;
				close(DAT);
				
				$new2{"$cf{rootdir}/html/$cat1/$cat2-$n.html"}++;
			}
		}
		if ($i % $cf{pg_max} != 0) {
			$html .= $foot;
			$html =~ s/!hit!/$c2num/;
			$html =~ s/!navi-ttl!/$$cat{$cat1}{$cat2}/;
			$html =~ s/!keyword!/$$cat{$cat1}{0} : $$cat{$cat1}{$cat2}/;
			$html =~ s|<!-- navi_nest -->|<a href="$cf{rooturl}/html/$cat1-1.html">$$cat{$cat1}{0}</a> &gt;|;
			$html =~ s/<!-- pager -->/make_pager($c2num,$n,$cat1,$cat2)/e;
			$html =~ s|<!-- cat_cell -->.+?<!-- /cat_cell -->||s;
			$html =~ s/<!-- cat2 -->/<input type="hidden" name="cat2" value="$cat2">/;
			
			# HTML生成 [小カテゴリ]
			open(DAT,"> $cf{rootdir}/html/$cat1/$cat2-$n.html");
			print DAT $html;
			close(DAT);
			
			$new2{"$cf{rootdir}/html/$cat1/$cat2-$n.html"}++;
		}
	}
	
	# 不要HTML整理
	for (@old1) {
		if (!defined $new1{$_}) { unlink($_); }
	}
	for (@old2) {
		if (!defined $new2{$_}) { unlink($_); }
	}
	
	# トップページ生成
	make_top($all,$tlnk) if (!$upd);
}

#-----------------------------------------------------------
#  TOP画面
#-----------------------------------------------------------
sub make_top {
	my ($all,$tlnk) = @_;
	
	my @categ = split(/;/,$cf{categ});
	
	# テンプレート読込
	open(IN,"$cf{tmpldir}/index.html") or error("open err: index.html");
	my $tmpl = join('',<IN>);
	close(IN);
	
	# 文字置き換え
	$tmpl =~ s|<!-- add_form -->.+?<!-- /add_form -->||sg if ($cf{reg_type} != 1);
	$tmpl =~ s/!(title|cmnurl|top_msg|[a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s|!topurl!|$cf{rooturl}/index.html|g;
	$tmpl =~ s/!all!/$all/g;
	$tmpl =~ s/<!-- op_cond -->/op_cond()/e;
	$tmpl =~ s/<!-- op_list -->/op_list()/e;
	$tmpl =~ s/!message!/$cf{top_msg}/;
	$tmpl =~ s/!new_site!/$cf{new_site}/;
	$tmpl =~ s/!rank_site!/$cf{rank_site}/;
	
	# テンプレート分割
	my ($head,$loop,$foot) = $tmpl =~ m|(.+)<!-- loop -->(.+?)<!-- /loop -->(.+)|s
			? ($1,$2,$3) : error("テンプレート不正");
	
	# ヘッダ
	my $html = $head;
	
	# カテゴリ展開
	my ($i,$tmp);
	for (0 .. $#categ) {
		$i++;
		my @cat = split(/,/,$categ[$_]);
		my $sub;
		for my $s (1 .. $#cat) {
			if (defined $$tlnk{"$_-$s"}) {
				$sub .= qq|<a href="$cf{rooturl}/html/$_/$s-1.html">$cat[$s]</a>,|;
			} else {
				$sub .= qq|$cat[$s],|;
			}
		}
		$sub =~ s/[,\s]+$//;
		
		$tmp = $loop;
		$tmp =~ s|!cate!|defined $$tlnk{$_} ? qq!<a href="$cf{rooturl}/html/$_-1.html">$cat[0]</a>! : $cat[0]|e;
		$tmp =~ s|!sub!|$sub|;
		$tmp =~ s|!catecnt!|<iframe src="$cf{navi_cgi}?mode=catecnt&cat=$_" width="35" height="20" scrolling="no" frameborder="0"></iframe>|;
		$html .= $tmp;
	}
	
	# フッタ
	$html .= footer($foot);
	
	# HTML生成
	open(DAT,"> $cf{rootdir}/index.html");
	print DAT $html;
	close(DAT);
}

#-----------------------------------------------------------
#  ページ送り作成
#-----------------------------------------------------------
sub make_pager {
	my ($i,$n,$cat1,$cat2) = @_;
	my $pg = ($n - 1) * $cf{pg_max};
	
	# ページ繰越数定義
	$cf{pg_max} ||= 10;
	my $next = $pg + $cf{pg_max};
	my $back = $pg - $cf{pg_max};
	
	# ページ繰越ボタン作成
	my ($cur,@pg);
	if ($back >= 0 || $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$cur = $x;
				$flg++;
				push(@pg,qq!<a href="#" class="page active">$x</a>\n!);
			} else {
				my $page = $cat2 eq '' ? "$cat1-$x" : "$cat1/$cat2-$x";
				push(@pg,qq!<a href="$cf{rooturl}/html/$page.html" class="page gradient">$x</a>\n!);
			}
			$x++;
			$y += $cf{pg_max};
			$z -= $cf{pg_max};
			
			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while(@pg >= 11) { shift(@pg); }
	my $ret = join('',@pg);
	if ($back >= 0) {
		my $key = ($back / $cf{pg_max}) + 1;
		my $page = $cat2 eq '' ? "$cat1-$key" : "$cat1/$cat2-$key";
		$ret = qq!<a href="$cf{rooturl}/html/$page.html" class="page gradient">&laquo;</a>\n! . $ret;
	}
	if ($next < $i) {
		my $key = ($next / $cf{pg_max}) + 1;
		my $page = $cat2 eq '' ? "$cat1-$key" : "$cat1/$cat2-$key";
		$ret .= qq!<a href="$cf{rooturl}/html/$page.html" class="page gradient">&raquo;</a>\n!;
	}
	
	# 結果を返す
	return $ret ? qq|<div class="pagination">\n$ret</div>| : '';
}

#-----------------------------------------------------------
#  小カテゴリリンク
#-----------------------------------------------------------
sub cat_cell {
	my ($loop,$cat,$cat1,$clnk) = @_;
	$loop =~ s/[\r\n]//g;
	my @cat = split(/,/,$cat);
	
	my ($i,$ret);
	for (1 .. $#cat) {
		$i++;
		my $tmp = $loop;
		if (defined $$clnk{"$cat1-$_"}) {
			$tmp =~ s|!cat_name!|<a href="$cf{rooturl}/html/$cat1/$_-1.html">$cat[$_]</a>\n|;
		} else {
			$tmp =~ s|!cat_name!|$cat[$_]\n|;
		}
		
		# 1行は4セル
		if ($i > 1 && $i % 4 == 1) { $ret .= "</tr><tr>\n"; }
		
		$ret .= $tmp;
	}
	
	return $ret;
}

#-----------------------------------------------------------
#  エラー画面
#-----------------------------------------------------------
sub error {
	my $err = shift;
	
	open(IN,"$cf{tmpldir}/error.html") or die;
	my $tmpl = join('',<IN>);
	close(IN);
	
	$tmpl =~ s|<!-- add_form -->.+?<!-- /add_form -->||sg if ($cf{reg_type} != 1);
	$tmpl =~ s/!(title|cmnurl|navi_cgi|admin_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!error!/$err/g;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" class="icon" alt="$1">|g;
	$tmpl =~ s|!topurl!|$cf{rooturl}/index.html|g;
	
	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  件数プルダウン
#-----------------------------------------------------------
sub op_list {
	my $ret;
	for ( split(/,/,$cf{op_list}) ) {
		$ret .= qq|<option value="$_">$_件\n|;
	}
	return $ret;
}

#-----------------------------------------------------------
#  条件プルダウン
#-----------------------------------------------------------
sub op_cond {
	my %cond = (1 => 'AND', 0 => 'OR');
	my $ret;
	for (1,0) {
		$ret .= qq|<option value="$_">$cond{$_}\n|;
	}
	return $ret;
}

#-----------------------------------------------------------
#  入力チェック
#-----------------------------------------------------------
sub input_check {

	if ($cf{reg_type} != 1) { error("登録は管理者のみです"); }

	my $err;
	if ($in{name} eq "") { $err .= "名前が未入力です<br>"; }

	if ($in{url} !~ /^https?:\/\/[\w-.!~*'();\/?:\@&=+\$,%#]+$/) {
		$err .= "URLの入力内容が不正です<br>";
	}
	if ($in{cate} eq "") { $err .= "分類が未選択です<br>"; }
	if ($in{sub} eq "") { $err .= "ページ名が未入力です<br>"; }
	if ($in{comment} eq "") { $err .= "紹介文が未入力です<br>"; }
	if (length($in{comment}) > $cf{com_limit} * 2) {
		$err .= "紹介文の文字数がオーバです<br>全角で$cf{com_limit}文字以内です<br>";
	}
	if ($in{'pw'} eq "") { $err .= "暗証キーが未入力です<br>"; }

	# 禁止ワード
	my $flg;
	foreach ( split(/,/, $cf{ng_word}) ) {
		if (index($in{comment},$_) >= 0) {
			$flg++;
			last;
		}
	}
	if ($flg) { $err .= "使用禁止用語が含まれています<br>"; }

	# エラー
	if ($err) { error($err); }
}

#-----------------------------------------------------------
#  添付アップロード
#-----------------------------------------------------------
sub upload {
	my $no = shift;

	# サムネイル機能
	require '../lib/thumb.pl' if ($cf{thumbnail});

	# 拡張子取得
	my $ext = $cgi->param_filename('upfile') =~ /(\.[^\\\/:\.]+)$/ ? $1 : error("拡張子不明");
	$ext =~ tr/A-Z/a-z/;
	if ($ext eq '.jpeg') { $ext = '.jpg'; }

	# ファイルチェック
	check_upl($ext);

	# 添付ファイル定義
	my $upfile = "$cf{upldir}/$no$ext";

	# アップロード書き込み
	open(UP,"+> $upfile") or error("up err: $upfile");
	binmode(UP);
	print UP $in{upfile};
	close(UP);

	chmod(0666, $upfile);

	# 画像サイズ取得
	my ($flg,$w,$h);
	if ($ext eq ".jpg") { ($w,$h) = j_size($upfile); $flg++; }
	elsif ($ext eq ".gif") { ($w,$h) = g_size($upfile); $flg++; }
	elsif ($ext eq ".png") { ($w,$h) = p_size($upfile); $flg++; }

	# サムネイル化
	if ($flg && $cf{thumbnail}) {
		($w,$h) = resize($w,$h);
		my $thumb = "$cf{imgdir}/$no-s$ext";
		make_thumb($upfile,$thumb,$w,$h);
	}

	# 結果を返す
	return ($ext,$w,$h);
}

#-----------------------------------------------------------
#  JPEGサイズ認識
#-----------------------------------------------------------
sub j_size {
	my $jpg = shift;

	my ($h, $w, $t);
	open(IMG,"$jpg");
	binmode(IMG);
	read(IMG, $t, 2);
	while (1) {
		read(IMG, $t, 4);
		my ($m, $c, $l) = unpack("a a n", $t);

		if ($m ne "\xFF") {
			$w = $h = 0;
			last;
		} elsif ((ord($c) >= 0xC0) && (ord($c) <= 0xC3)) {
			read(IMG, $t, 5);
			($h, $w) = unpack("xnn", $t);
			last;
		} else {
			read(IMG, $t, ($l - 2));
		}
	}
	close(IMG);

	return ($w, $h);
}

#-----------------------------------------------------------
#  GIFサイズ認識
#-----------------------------------------------------------
sub g_size {
	my $gif = shift;

	my $data;
	open(IMG,"$gif");
	binmode(IMG);
	sysread(IMG, $data, 10);
	close(IMG);

	if ($data =~ /^GIF/) { $data = substr($data, -4); }
	my $w = unpack("v", substr($data, 0, 2));
	my $h = unpack("v", substr($data, 2, 2));

	return ($w, $h);
}

#-----------------------------------------------------------
#  PNGサイズ認識
#-----------------------------------------------------------
sub p_size {
	my $png = shift;

	my $data;
	open(IMG,"$png");
	binmode(IMG);
	read(IMG, $data, 24);
	close(IMG);

	my $w = unpack("N", substr($data, 16, 20));
	my $h = unpack("N", substr($data, 20, 24));

	return ($w, $h);
}

#-----------------------------------------------------------
#  ファイルチェック
#-----------------------------------------------------------
sub check_upl {
	my ($ext) = @_;

	# mimeタイプ
	my $mime = $cgi->param_mime('upfile');

	# text
	my $flg;
	if ($ext eq '.gif' && $cf{ok_gif} && $mime =~ /^image\/gif$/i) { $flg++; }
	elsif ($ext eq '.png' && $cf{ok_png} && $mime =~ /^image\/(x-)?png$/i) { $flg++; }
	elsif ($ext eq '.jpg' && $cf{ok_jpeg} && $mime =~ /^image\/p?jpe?g$/i) { $flg++; }

	if (!$flg) { error('このファイルは取り扱いできません'); }
}

#-----------------------------------------------------------
#  フッター
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 著作権表記（削除・改変禁止）
	my $copy = <<EOM;
<p style="margin-top:1em;text-align:center;font-family:Verdana,Helvetica,Arial;font-size:11pt;">
- <a href="http://www.kent-web.com/" target="_top">$cf{version}</a> -<br>
++ <a href="http://www.transformsite.com/" target="_top">Edited by Hamel</a> ++
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  crypt暗号
#-----------------------------------------------------------
sub encrypt {
	my $in = shift;

	my @wd = ('a'..'z', 'A'..'Z', '0'..'9', '.', '/');
	srand;
	my $salt = $wd[int(rand(@wd))] . $wd[int(rand(@wd))];
	crypt($in, $salt) || crypt ($in, '$1$' . $salt);
}

#-----------------------------------------------------------
#  crypt照合
#-----------------------------------------------------------
sub decrypt {
	my ($in, $dec) = @_;

	my $salt = $dec =~ /^\$1\$(.*)\$/ ? $1 : substr($dec, 0, 2);
	if (crypt($in, $salt) eq $dec || crypt($in, '$1$' . $salt) eq $dec) {
		return 1;
	} else {
		return 0;
	}
}

#-----------------------------------------------------------
#  時間取得
#-----------------------------------------------------------
sub get_time {
	my ($time) = @_;

	my ($min,$hour,$mday,$mon,$year,$wday) = (localtime($time))[1..6];
	sprintf("%04d/%02d/%02d-%02d:%02d",	$year+1900,$mon+1,$mday,$hour,$min);
}

#-----------------------------------------------------------
#  ホスト名取得
#-----------------------------------------------------------
sub get_host {
	my $host = $ENV{'REMOTE_HOST'};
	my $addr = $ENV{'REMOTE_ADDR'};

	if ($cf{gethostbyaddr} && ($host eq "" || $host eq $addr)) {
		$host = gethostbyaddr(pack("C4", split(/\./, $addr)), 2);
	}
	if ($host eq "") { $host = $addr; }

	return ($host,$addr);
}

#-----------------------------------------------------------
#  完了メッセージ
#-----------------------------------------------------------
sub message {
	my ($msg) = @_;

	open(IN,"$cf{tmpldir}/mesg.html") or &error("open err: mesg.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!navi_cgi!/$cf{navi_cgi}/g;
	$tmpl =~ s/!cmnurl!/$cf{cmnurl}/g;
	$tmpl =~ s/!message!/$msg/g;
	$tmpl =~ s|!topurl!|$cf{rooturl}/index.html|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  mimeエンコード
#  [quote] http://www.din.or.jp/~ohzaki/perl.htm#JP_Base64
#-----------------------------------------------------------
sub mime_unstructured_header {
  my $oldheader = shift;
  jcode::convert(\$oldheader,'euc','utf8');
  my ($header,@words,@wordstmp,$i);
  my $crlf = $oldheader =~ /\n$/;
  $oldheader =~ s/\s+$//;
  @wordstmp = split /\s+/, $oldheader;
  for ($i = 0; $i < $#wordstmp; $i++) {
    if ($wordstmp[$i] !~ /^[\x21-\x7E]+$/ and
	$wordstmp[$i + 1] !~ /^[\x21-\x7E]+$/) {
      $wordstmp[$i + 1] = "$wordstmp[$i] $wordstmp[$i + 1]";
    } else {
      push(@words, $wordstmp[$i]);
    }
  }
  push(@words, $wordstmp[-1]);
  foreach my $word (@words) {
    if ($word =~ /^[\x21-\x7E]+$/) {
      $header =~ /(?:.*\n)*(.*)/;
      if (length($1) + length($word) > 76) {
	$header .= "\n $word";
      } else {
	$header .= $word;
      }
    } else {
      $header = add_encoded_word($word, $header);
    }
    $header =~ /(?:.*\n)*(.*)/;
    if (length($1) == 76) {
      $header .= "\n ";
    } else {
      $header .= ' ';
    }
  }
  $header =~ s/\n? $//mg;
  $crlf ? "$header\n" : $header;
}
sub add_encoded_word {
  my ($str, $line) = @_;
  my $result;
  my $ascii = '[\x00-\x7F]';
  my $twoBytes = '[\x8E\xA1-\xFE][\xA1-\xFE]';
  my $threeBytes = '\x8F[\xA1-\xFE][\xA1-\xFE]';
  while (length($str)) {
    my $target = $str;
    $str = '';
    if (length($line) + 22 +
	($target =~ /^(?:$twoBytes|$threeBytes)/o) * 8 > 76) {
      $line =~ s/[ \t\n\r]*$/\n/;
      $result .= $line;
      $line = ' ';
    }
    while (1) {
      my $encoded = '=?ISO-2022-JP?B?' .
      b64encode(jcode::jis($target,'euc','z')) . '?=';
      if (length($encoded) + length($line) > 76) {
	$target =~ s/($threeBytes|$twoBytes|$ascii)$//o;
	$str = $1 . $str;
      } else {
	$line .= $encoded;
	last;
      }
    }
  }
  $result . $line;
}
# [quote] http://www.tohoho-web.com/perl/encode.htm
sub b64encode {
    my $buf = shift;
    my ($mode,$tmp,$ret);
    my $b64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
                . "abcdefghijklmnopqrstuvwxyz"
                . "0123456789+/";
	
    $mode = length($buf) % 3;
    if ($mode == 1) { $buf .= "\0\0"; }
    if ($mode == 2) { $buf .= "\0"; }
    $buf =~ s/(...)/{
        $tmp = unpack("B*", $1);
        $tmp =~ s|(......)|substr($b64, ord(pack("B*", "00$1")), 1)|eg;
        $ret .= $tmp;
    }/eg;
    if ($mode == 1) { $ret =~ s/..$/==/; }
    if ($mode == 2) { $ret =~ s/.$/=/; }
    
    return $ret;
}
